﻿using NMemory;
using NMemory.Constraints;
using NMemory.Tables;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Database database = new Database();

        Table<Member, int> memberTable = database.Tables.Create<Member, int>(member => member.ID, null);

        memberTable.Contraints.Add(new NotNullableConstraint<Member, string>(member => member.Name));

        memberTable.Insert(new Member() { ID = 1, Name = "김철수" });
        memberTable.Insert(new Member() { ID = 2, Name = "홍길동" });
        memberTable.Insert(new Member() { ID = 3, Name = "홍삼수" });
        memberTable.Insert(new Member() { ID = 4, Name = "김영희" });
        memberTable.Insert(new Member() { ID = 5, Name = "이주희" });

        foreach(Member member in memberTable)
        {
            Console.WriteLine($"{member.ID}, {member.Name}");
        }

        memberTable.Insert(new Member() { ID = 6 }); // ConstraintException 예외가 발생한다.
    }

    #endregion
}